var _ = require('underscore'),
    config = require('./config'),
    fu = require('./fileUtil'),
    glob = require('glob');

function Mixins(options) {
  this.options = options;
}

Mixins.prototype.initialize = function(config) {
  this.mixins = [];

  // load command line plugins
  _.each(this.options.mixins, loadMixin, this);

  // load lumbar.json plugins
  var fileMixins = config.attributes.mixins;
  if (fileMixins && fileMixins.auto) {
    // Auto wired mixins. Scan the directory for lumbar.json files.
  } else {
    _.each(fileMixins, loadMixin, this);
  }
};

function loadMixin(mixinConfig, root) {
  // Allow mixins to be passed directly
  if (!_.isObject(mixinConfig)) {
    root = root || mixinConfig;
    mixinConfig = config.readConfig(mixinConfig + '/lumbar.json');
  }

  var mixins = mixinConfig.mixins;
  delete mixinConfig.mixins;

  // Read each of the mixins that are defined in the config
  _.each(mixins, function(mixin, name) {
    this.mixins[name] = {
      attributes: mixin,
      parent: mixinConfig,
      root: root
    };
  }, this);
}

module.exports = Mixins;
